import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;

//XvCggp(LoX)
public class SpriteCanvas extends GameCanvas
    implements Runnable {
    final static int[][] MAP_DATA={//}bvf[^
        {1,1,1,1,1,1,1,1,1,1},
        {1,0,0,0,0,0,1,0,0,1},
        {1,0,0,0,0,0,1,1,0,1},
        {1,0,1,1,1,1,1,1,0,1},
        {1,0,0,1,0,0,0,1,0,1},
        {1,1,0,1,0,1,1,1,0,1},
        {1,0,0,1,0,0,0,0,0,1},
        {1,0,1,1,0,1,0,1,1,1},
        {1,0,0,0,0,1,0,0,2,1},
        {1,1,1,1,1,1,1,1,1,1}};

    Image girlImg;//̎qC[W
    Image mapImg; //}bvC[W

    //RXgN^
    SpriteCanvas() {
        //L[Cxg̗}
        super(false);
    }

    //s
    public void run() {
        Graphics g=getGraphics();//OtBbN
        int      keyState;       //L[

        //摜t@C̓ǂݍ
        try {
            girlImg=Image.createImage("/girl.png");
            mapImg =Image.createImage("/map.png");
        } catch (Exception e) {
        }

        //XvCg
        Sprite girl=new Sprite(girlImg,24,24);
        girl.setPosition(96,48);
        girl.setFrameSequence(new int[]{0,1,0,2});
        int moveX=0;//Xړ
        int moveY=0;//Yړ

        //^CC[
        TiledLayer map=new TiledLayer(10,10,mapImg,24,24);
        for (int j=0;j<MAP_DATA.length;j++) {
            for (int i=0;i<MAP_DATA[j].length;i++) {
                map.setCell(i,j,MAP_DATA[j][i]);
            }
        }

        //C[}l[W[
        LayerManager manager=new LayerManager();
        manager.append(girl);
        manager.append(map);

        while (true) {
            //L[Ԃ̎擾
            keyState=getKeyStates();

            //ړ
            if (keyState!=0) girl.nextFrame();
            moveX=0;
            moveY=0;
            if ((LEFT_PRESSED &keyState)!=0) moveX=-8;
            if ((RIGHT_PRESSED&keyState)!=0) moveX=8;
            if ((UP_PRESSED   &keyState)!=0) moveY=-8;
            if ((DOWN_PRESSED &keyState)!=0) moveY=8;

            //ړʕi
            girl.move(moveX,moveY);

            //Փˎ͈ړʕ߂
            if (girl.collidesWith(map,false)) {
                girl.move(-moveX,-moveY);
            }

            //_̎w
            manager.setViewWindow(
                girl.getX()-(getWidth()-48)/2,
                girl.getY()-(getHeight()-48)/2,
                getWidth(),getHeight());

            //ʂ̕`
            g.setColor(255,238,170);
            g.fillRect(0,0,getWidth(),getHeight());
            manager.paint(g,0,0);
            flushGraphics();

            //X[v
            try {
                Thread.sleep(100);
            } catch (Exception e) {
            }
        }
    }
}