import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.io.*;
import java.util.*;
import org.kxml2.io.*;
import org.xmlpull.v1.*;

//RSS[_[({)
public class RSSReader extends MIDlet
    implements CommandListener,Runnable {
    //萔
    final static String URL="http://slashdot.jp/slashdot.rdf";
    final static String ENCODE="UTF-8";

    //ϐ
    KXmlParser parser;            //p[T[
    List       list;              //Xg
    Vector     links=new Vector();//NS

    //RXgN^
    public RSSReader() {
        //Xg̐
        list=new List("RSS[_[",Choice.IMPLICIT);
        list.setCommandListener(this);
        Display.getDisplay(this).setCurrent(list);

        //XbhJn
        (new Thread(this)).start();
    }

    //Av̊Jn
    public void startApp() {
    }

    //Av̈ꎞ~
    public void pauseApp() {
    }
    //Av̏I
    public void destroyApp(boolean flag) {
    }

    //R}hCxg
    public void commandAction(Command c, Displayable s) {
        //XgI
        if (c==List.SELECT_COMMAND) {
            try {
                String link=(String)links.elementAt(
                    list.getSelectedIndex());
                platformRequest(link);
            } catch (Exception e) {
            }
        }
    }

    //Xbh̏
    public void run() {
        int    type;//
        String name;//O
        try {
            //lbgƐڑ
            HttpConnection c=(HttpConnection)Connector.open(URL);
            if (c.getResponseCode()!=HttpConnection.HTTP_OK) {
                throw new Exception();
            }

            //p[T[𐶐
            parser=new KXmlParser();
            parser.setInput(c.openInputStream(),ENCODE);
            parser.next();
            while (true) {
                //擾
                type=parser.next();
                if (type==KXmlParser.END_DOCUMENT) return;
                name=parser.getName();
                if (name==null) continue;

                //<title>
                if (type==KXmlParser.START_TAG &&
                    name.equals("title")) {
                    parser.next();
                    list.setTitle(parser.getText());
                    if (!skipEndTag("title")) return;
                }
                //<item>
                else if (type==KXmlParser.START_TAG &&
                    name.equals("item")) {
                    String itemTitle=null;
                    String itemLink =null;
                    while (true) {
                        //擾
                        type=parser.next();
                        if (type==KXmlParser.END_DOCUMENT) return;
                        name=parser.getName();
                        if (name==null) continue;

                        //<title>
                        if (type==KXmlParser.START_TAG &&
                            name.equals("title")) {
                            parser.next();
                            itemTitle=parser.getText();
                            if (!skipEndTag("title")) return;
                        }
                        //<link>
                        else if (type==KXmlParser.START_TAG &&
                            name.equals("link")) {
                            parser.next();
                            itemLink=parser.getText();
                            if (!skipEndTag("link")) return;
                         }
                         //</item>
                         else if (type==KXmlParser.END_TAG &&
                            name.equals("item")) {
                            if (itemTitle!=null && itemLink!=null) {
                                list.append(itemTitle,null);
                                links.addElement(itemLink);
                            }
                            break;
                        }
                    }
                }
                //<channel>
                else if (type==KXmlParser.START_TAG &&
                    name.equals("channel")) {
                }
                //̃^OJnʒu
                else if (type==KXmlParser.START_TAG) {
                    if (!skipEndTag(name)) return;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            showErrorDialog("ʐMG[ł");
        }
    }

    //G[_CAO̕\
    void showErrorDialog(String text) {
        Alert alert=new Alert("G[",text,null,AlertType.ERROR);
        alert.setTimeout(Alert.FOREVER);
        (Display.getDisplay(this)).setCurrent(alert);
    }

    //^OIʒuփXLbv
    boolean skipEndTag(String name) {
        try {
            while (true) {
                int type=parser.next();
                //Iʒu
                if (type==KXmlParser.END_DOCUMENT) return false;
                //^OIʒu
                if (type==KXmlParser.END_TAG &&
                    name.equals(parser.getName())) return true;
            }
        } catch (Exception e) {
            return false;
        }
    }
}