import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;
import javax.microedition.m3g.*;

//3DOtBbNX̃v~eBu\(LoX)
class PrimitiveCanvas extends GameCanvas
    implements Runnable {

    //RXgN^
    PrimitiveCanvas() {
        super(true);
    }

    //s
    public void run() {
        //OtBbNX3D̐
        Graphics   g =getGraphics();
        Graphics3D g3=Graphics3D.getInstance();

        //J̐
        Camera camera=new Camera();
        camera.setPerspective(60.0f,             //r[̃tB[h
            (float)getWidth()/(float)getHeight(),//AXyNg
            1.0f,                                //jANbv
            1000.0f);                            //t@[Nbv
        float angle=0.0f;//px

        //̐
        Light light=new Light();
        light.setMode(Light.AMBIENT);//
        light.setColor(0xFFFFFF);    //
        light.setIntensity(10.0f);    //x


        //ʒu̐
        // 1 * * * * * 0
        //   * *     *
        //   *   *   *
        //   *     * *
        // 3 * * * * * 2
        short[] pos={
            10, 10, 10, -10, 10, 10,  10,-10, 10, -10,-10, 10,  //O
           -10, 10,-10,  10, 10,-10, -10,-10,-10,  10,-10,-10,  //
           -10, 10, 10, -10, 10,-10, -10,-10, 10, -10,-10,-10,  //
            10, 10,-10,  10, 10, 10,  10,-10,-10,  10,-10, 10,  //E
            10, 10,-10, -10, 10,-10,  10, 10, 10, -10, 10, 10,  //
            10,-10, 10, -10,-10, 10,  10,-10,-10, -10,-10,-10 };//
        VertexArray posArray=new VertexArray(pos.length/3,3,2);
        posArray.set(0,pos.length/3,pos);

        //@̐
        byte[] norm={
             0, 0, 127,  0, 0, 127,  0, 0, 127,  0, 0, 127,
             0, 0,-127,  0, 0,-127,  0, 0,-127,  0, 0,-127,
            -127, 0, 0, -127, 0, 0, -127, 0, 0, -127, 0, 0,
             127, 0, 0,  127, 0, 0,  127, 0, 0,  127, 0, 0,
             0, 127, 0,  0, 127, 0,  0, 127, 0,  0, 127, 0,
             0,-127, 0,  0,-127, 0,  0,-127, 0,  0,-127, 0};
        VertexArray normArray = new VertexArray(norm.length/3,3,1);
        normArray.set(0,norm.length/3,norm);

        //eNX`W̐
        short[] tex={
            1,0,  0,0,  1,1,  0,1,
            1,0,  0,0,  1,1,  0,1,
            1,0,  0,0,  1,1,  0,1,
            1,0,  0,0,  1,1,  0,1,
            1,0,  0,0,  1,1,  0,1,
            1,0,  0,0,  1,1,  0,1 };
        VertexArray texArray=new VertexArray(tex.length/2,2,2);
        texArray.set(0,tex.length/2,tex);

        //_obt@̐
        VertexBuffer vb=new VertexBuffer();
        vb.setPositions(posArray,1.0f,null);
        vb.setNormals(normArray);
        vb.setTexCoords(0,texArray,1.0f,null);

        //CfbNXobt@̐
        int[] stripLen={4,4,4,4,4,4};
        IndexBuffer ib=new TriangleStripArray(0,stripLen);


        //eNX`̐
        Image image=null;
        try {
            image=Image.createImage("/texture.png");     //C[W
        } catch (Exception e) {
        }
        Image2D   image2D=new Image2D(Image2D.RGB,image);//C[W2D
        Texture2D texture=new Texture2D(image2D);        //eNX`2D

        //AsAX̐
        Appearance appearance=new Appearance();
        appearance.setTexture(0,texture);//eNX`


        //wi̐
        Background background=new Background();
        background.setColor(0xFFFFFFAA);//F

        while (true) {
            //^[Qbg̃oCh
            g3.bindTarget(g);

            //J[obt@EfuXobt@̃NA
            g3.clear(background);

            //J̎w
            Transform transform=new Transform();
            transform.postTranslate(0.0f,-5.0f,40.0f);
            g3.setCamera(camera,transform);

            //̎w
            g3.resetLights();
            g3.addLight(light,transform);

            //L[ủ]
            angle+=1.0f;
            transform.setIdentity();
            transform.postRotate(angle,1.0f,1.0f,1.0f);

            //L[ũ_O
            g3.render(vb,ib,appearance,transform);

            //^[Qbg̃[X
            g3.releaseTarget();

            //`̔f
            flushGraphics();

            //X[v
            try {
                Thread.sleep(50);
            } catch (Exception e) {
            }
        }
    }
}