import javax.microedition.lcdui.*;

//L[CxgE|C^Cxg(LoX)
class KeyEventCanvas extends Canvas
    implements CommandListener {
    Command[] command=new Command[2];//R}h
    String    info   ="Ȃ";        //

    //RXgN^
    KeyEventCanvas() {
        //R}h̐
        command[0]=new Command("R}h1",Command.SCREEN,0);
        command[1]=new Command("R}h2",Command.SCREEN,1);

        //R}h̒ǉ
        addCommand(command[0]);
        addCommand(command[1]);

        //R}hXi[̎w
        setCommandListener(this);
    }

    //`
    public void paint(Graphics g) {
        g.setColor(255,255,255);
        g.fillRect(0,0,getWidth(),getHeight());
        g.setColor(0,0,0);
        g.drawString("L[F"+info,0,5,g.LEFT|g.TOP);
    }

    //L[vXCxg
    public void keyPressed(int keyCode) {
        if (keyCode==0) return;
        switch(keyCode) {
        //L[ELL[
        case KEY_NUM0: info="0";break;
        case KEY_NUM1: info="1";break;
        case KEY_NUM2: info="2";break;
        case KEY_NUM3: info="3";break;
        case KEY_NUM4: info="4";break;
        case KEY_NUM5: info="5";break;
        case KEY_NUM6: info="6";break;
        case KEY_NUM7: info="7";break;
        case KEY_NUM8: info="8";break;
        case KEY_NUM9: info="9";break;
        case KEY_STAR: info="*";break;
        case KEY_POUND:info="#";break;
        //L[EIL[
        default:
            switch(getGameAction(keyCode)) {
            case UP:     info="";break;
            case DOWN:   info="";break;
            case LEFT:   info="";break;
            case RIGHT:  info="E";break;
            case FIRE:   info="I";break;
            case GAME_A: info="GAME A";break;
            case GAME_B: info="GAME B";break;
            case GAME_C: info="GAME C";break;
            case GAME_D: info="GAME D";break;
            default:     info="KeyCode "+keyCode;break;
            }
        }
        repaint();
    }

    //L[[XCxg
    public void keyReleased(int keyCode) {
        info="Ȃ";
        repaint();
    }

    //R}hCxg
    public void commandAction(Command c,Displayable disp) {
        if (c==command[0]) info="R}h1";
        if (c==command[1]) info="R}h2";
        repaint();
    }

    //|C^vXCxg
    public void pointerPressed(int x,int y) {
        info="|C^vX("+x+","+y+")";
        repaint();
    }

    //|C^hbOCxg
    public void pointerDragged(int x,int y) {
        info="|C^hbO("+x+","+y+")";
        repaint();
    }

    //|C^[XCxg
    public void pointerReleased(int x,int y) {
        info="Ȃ";
        repaint();
    }
}