import javax.microedition.lcdui.*;
import java.util.*;

//ToDoXg(CXg)
class MainList extends List
    implements CommandListener {
    private Image[]   image  =new Image[2];  //C[W
    private Command[] command=new Command[3];//R}h
    private Vector    todos  =new Vector();  //ToDoS

    //RXgN^
    public MainList(){
        super("ToDoXg",Choice.IMPLICIT);

        //C[W̓ǂݍ
        try {
            image[0]=Image.createImage("/0.png");
            image[1]=Image.createImage("/1.png");
        } catch (Exception e) {
        }

        //R}h
        command[0]=new Command("I",Command.SCREEN,0);
        setSelectCommand(command[0]);
        command[1]=new Command("ǉ",Command.SCREEN,1);
        addCommand(command[1]);
        command[2]=new Command("폜",Command.SCREEN,2);
        addCommand(command[2]);
        setCommandListener(this);

        //
        init();
    }

    //
    void init() {
        //ڑS폜
        deleteAll();
        //ڒǉ
        for (int i=0;i<todos.size();i++) {
            ToDo todo=(ToDo)todos.elementAt(i);
            append(todo.plan,image[todo.state]);
        }
    }

    //ToDo̒ǉ
    void addToDo(ToDo todo) {
        todos.addElement(todo);
    }

    //R}hCxg
    public void commandAction(Command c,Displayable s) {
        int idx;
        //I
        if (c==command[0]) {
            idx=getSelectedIndex();
            if (idx<0) {
                showAlert("ڂIĂ܂");
            } else {
                ToDoList.todoForm.setToDo((ToDo)todos.elementAt(idx));
                (Display.getDisplay(ToDoList.midlet)).
                    setCurrent(ToDoList.todoForm);
            }
        }
        //ǉ
        if (c==command[1]) {
            ToDoList.todoForm.setToDo(null);
            (Display.getDisplay(ToDoList.midlet)).
                setCurrent(ToDoList.todoForm);
        }
        //폜
        if (c==command[2]) {
            idx=getSelectedIndex();
            if (idx<0) {
                showAlert("ڂIĂ܂");
            } else {
                todos.removeElementAt(idx);
                init();
            }
        }
    }

    //A[g̕\
    void showAlert(String message) {
        Alert alert=new Alert("x",
            message,null,AlertType.WARNING);
        alert.setTimeout(Alert.FOREVER);
        (Display.getDisplay(ToDoList.midlet)).setCurrent(alert);
    }
}