import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;
import java.util.*;

//V[eBOQ[(LoX)
class ShootingCanvas extends GameCanvas
    implements Runnable,CommandListener {
    //V[萔
    private final static int
        S_PLAY    =0,//vC
        S_GAMEOVER=1;//Q[I[o[

    //_̏Ԓ萔
    private final static int
        B_NONE=-1,//Ȃ
        B_FLY =0, //s
        B_BOM =1; //

    //VXe
    private static int      scene;             //V[
    private static int      init =S_PLAY;      //
    private static int      key;               //L[
    private static int      score;             //XRA
    private static Graphics g;                 //OtBbNX
    private static Image[]  image=new Image[4];//C[W
    private static Random   rand =new Random();//
    private static Command  cmdRestart;        //X^[g

    //Ə
    private static int targetX; //XW
    private static int targetY; //YW
    private static int targetMX;//ړXW
    private static int targetMY;//ړYW

    //_
    private static int[] bugState=new int[8];//
    private static int[] bugX    =new int[8];//XW
    private static int[] bugY    =new int[8];//YW

    //RXgN^
    ShootingCanvas() {
        super(false);
    }

    //Xbh̏
    public void run() {
        long sleepTime=0;
        try {
            //OtBbNX̎擾
            g=getGraphics();

            //C[Wǂݍ
            for (int i=0;i<4;i++) {
                image[i]=Image.createImage("/"+i+".png");
            }

            //X^[g
            cmdRestart=new Command("ؽ",Command.SCREEN,0);
            addCommand(cmdRestart);
            setCommandListener(this);

            //C[v
            while (true) {
                //Iȏ
                tick();

                //X[v
                while (System.currentTimeMillis()<sleepTime+100);
                sleepTime=System.currentTimeMillis();
            }
        } catch (Exception e) {
        }
    }

    //Iȏ
    private void tick() {
        int i,j,ks;

        //
        if (init>=0) {
            scene=init;
            init =-1;
            //vC
            if (scene==S_PLAY) {
                score=0;
                targetX=getWidth()/2;
                targetY=getHeight()/2;
                targetMX=-1;
                targetMY=-1;
                for (i=0;i<8;i++) bugState[i]=B_NONE;
            }
            key=-999;
        }

        //wi
        g.setColor(220,220,220);
        g.fillRect(0,0,getWidth(),getHeight());
        g.setColor(210,210,210);
        g.fillRect(0,getHeight()-9,getWidth(),3);
        g.setColor(190,190,190);
        g.fillRect(0,getHeight()-6,getWidth(),3);
        g.setColor(160,160,160);
        g.fillRect(0,getHeight()-3,getWidth(),3);

        //_
        j=(rand.nextInt()>>>1)%100;
        for (i=0;i<8;i++) {
            //o
            if (bugState[i]==B_NONE && j<5) {
                bugX[i]    =8+(rand.nextInt()>>>1)%(getWidth()-16);
                bugY[i]    =-16;
                bugState[i]=B_FLY;
                j=99;
            }
            //s
            if (bugState[i]==B_FLY) {
                g.drawImage(image[2],bugX[i]-10,bugY[i]-10,g.LEFT|g.TOP);
                bugY[i]++;
                if (score>300) bugY[i]++;
                if (score>600) bugY[i]++;
                if (bugY[i]>getHeight()+10) bugState[i]=B_NONE;
            }
            //
            else if (bugState[i]==B_BOM) {
                g.drawImage(image[3],bugX[i]-12,bugY[i]-12,g.LEFT|g.TOP);
                bugState[i]=B_NONE;
            }
        }

        //vC
        if (scene==S_PLAY) {
            //Q[I[o[`FbN
            for (i=7;i>=0;i--) {
                if (bugState[i]!=B_NONE && bugY[i]>getHeight()-18) {
                    init=S_GAMEOVER;
                }
            }

            //XRA
            score++;

            //t@C[
            ks=getKeyStates();
            if (key==FIRE) {
                g.setColor(255,50,50);
                g.fillRect(targetX-1,targetY,3,getHeight()-40-targetY);
                for (i=0;i<8;i++) {
                    if (bugState[i]==B_FLY) {
                        if (targetX-8<=bugX[i] && bugX[i]<=targetX+8 &&
                            targetY-8<=bugY[i] && bugY[i]<=targetY+8) {
                            bugState[i]=B_BOM;
                        }
                    }
                }
            }
            key=-999;

            //|CeBOfoCXɂƏړ
            if (targetMX>0 && targetX>=targetMX+8) targetX-=8;
            if (targetMX>0 && targetX<=targetMX-8) targetX+=8;
            if (targetMY>0 && targetY>=targetMY+8) targetY-=8;
            if (targetMY>0 && targetY<=targetMY-8) targetY+=8;

            //L[ɂƏړ
            if ((LEFT_PRESSED&ks) !=0) targetX-=8;
            if ((RIGHT_PRESSED&ks)!=0) targetX+=8;
            if ((UP_PRESSED&ks)   !=0) targetY-=8;
            if ((DOWN_PRESSED&ks) !=0) targetY+=8;

            //Ə̈ʒu␳
            if (targetX<12            ) targetX=12;
            if (targetX>getWidth()-12 ) targetX=getWidth()-12;
            if (targetY<12            ) targetY=12;
            if (targetY>getHeight()-12) targetY=getHeight()-12;

            //Ə̕`
            g.drawImage(image[1],targetX-7,targetY-7,g.LEFT|g.TOP);
        }
        //Q[I[o[
        else {
            drawBold(g,"Q[I[o[",getWidth()/2,getHeight()/3);
        }

        //XRA
        g.setColor(255,50,50);
        g.drawString(String.valueOf(score),6,6,g.LEFT|g.TOP);

        //̎q
        g.drawImage(image[0],targetX-12,getHeight()-40,g.LEFT|g.TOP);
        flushGraphics();
    }

    //̕`
    void drawBold(Graphics g,String str,int x,int y) {
        g.setColor(255,155,155);
        g.drawString(str,x-1,y-1,g.HCENTER|g.BASELINE);
        g.drawString(str,x  ,y-1,g.HCENTER|g.BASELINE);
        g.drawString(str,x+1,y-1,g.HCENTER|g.BASELINE);
        g.drawString(str,x-1,y  ,g.HCENTER|g.BASELINE);
        g.drawString(str,x+1,y  ,g.HCENTER|g.BASELINE);
        g.drawString(str,x-1,y+1,g.HCENTER|g.BASELINE);
        g.drawString(str,x  ,y+1,g.HCENTER|g.BASELINE);
        g.drawString(str,x+1,y+1,g.HCENTER|g.BASELINE);
        g.setColor(255,0,0);
        g.drawString(str,x,y,g.HCENTER|g.BASELINE);
    }

    //R}hCxg
    public void commandAction(Command c,Displayable s) {
        if (c==cmdRestart) init=S_PLAY;
    }

    //L[vXCxg
    public void keyPressed(int keyCode) {
        if (keyCode!=0) key=getGameAction(keyCode);
    }

    //|C^vXCxg
    public void pointerPressed(int x,int y) {
        targetMX=x;
        targetMY=y;
    }

    //|C^[XCxg
    public void pointerReleased(int x,int y) {
        targetMX=-1;
        targetMY=-1;
        key     =FIRE;
    }

    //`
    public void paint(Graphics g) {}
}