import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import java.io.*;
import java.util.*;

//ڊo܂v(tH[)
class WakeUpForm extends Form
    implements CommandListener,Runnable {
    //GUI
    private StringItem clockItem;//v
    private Command    cmdSetup; //A[ݒR}h
    private Player     player;   //vC[

    //A[
    private DateField   alarmField; //̓tB[h
    private ChoiceGroup alarmChoice;//`CX
    private boolean     alarmShow;  //\

    //RXgN^
    WakeUpForm(){
        super("ւ܃NbN");

        //v
        clockItem=new StringItem("","");
        clockItem.setLayout(Item.LAYOUT_2|Item.LAYOUT_CENTER|
            Item.LAYOUT_NEWLINE_AFTER);
        append(clockItem);

        Image image=null;
        try {
            //C[W̓ǂݍ
            image=Image.createImage("/cat.jpg");

            //TEht@C̓ǂݍ
            InputStream in=getClass().getResourceAsStream("/cat.wav");
            player=Manager.createPlayer(in,"audio/wav");
            player.prefetch();
        } catch (Exception e) {
            e.printStackTrace();
        }

        //C[W
        ImageItem imageItem=new ImageItem("",image,
            Item.LAYOUT_2|Item.LAYOUT_CENTER,"",Item.PLAIN);
        append(imageItem);

        //A[
        alarmField=new DateField("",DateField.TIME);
        alarmField=new DateField("",DateField.TIME);
        alarmChoice=new ChoiceGroup("",Choice.MULTIPLE);
        alarmChoice.append("װ",null);
        alarmShow=false;

        //R}h
        cmdSetup=new Command("","װ",Command.SCREEN,0);
        addCommand(cmdSetup);
        setCommandListener(this);

        //Xbh̊Jn
        (new Thread(this)).start();
    }

    //ACeCxg
    public void commandAction(Command c,Displayable s)  {
        //A[ݒ
        if (c==cmdSetup) {
            alarmShow=!alarmShow;

            //A[ݒ\
            if (alarmShow) {
                insert(1,alarmChoice);
                insert(1,alarmField);
            }
            //A[ݒ\
            else {
                delete(1);
                delete(1);
            }
        }
    }

    //Xbh̏
    public void run() {
        String WEEK="@ΐ؋y";
        Calendar cal;    //J_[

        //ݎ
        int year;        //N
        int month;       //
        int day_of_month;//
        int day_of_week; //j
        int hour;        //
        int minute;      //
        int second;      //b

        //A[
        int alarmHour;  //
        int alarmMinute;//
        while (true) {
            //ݎ̎擾
            cal         =Calendar.getInstance();
            cal.setTime(new Date(cal.getTime().getTime()+9*60*60*1000)); //ǉ
            year        =cal.get(Calendar.YEAR);
            month       =cal.get(Calendar.MONTH)+1;
            day_of_month=cal.get(Calendar.DAY_OF_MONTH);
            day_of_week =cal.get(Calendar.DAY_OF_WEEK);
            hour        =cal.get(Calendar.HOUR_OF_DAY);
            minute      =cal.get(Calendar.MINUTE);
            second      =cal.get(Calendar.SECOND);

            //A[̎擾
            if (alarmChoice.isSelected(0) &&
                alarmField.getDate()!=null) {
                cal.setTime(alarmField.getDate());
                alarmHour  =cal.get(Calendar.HOUR_OF_DAY);
                alarmMinute=cal.get(Calendar.MINUTE);

                //A[Đ
                if (alarmHour==hour && alarmMinute==minute &&
                    player.getState()!=Player.STARTED) {
                    try {
                        player.start();
                    } catch (Exception e) {
                    }
                }
            }

            //v̕\
            clockItem.setText(
                year                       +"/"+
                formatNum(month," ")       +"/"+
                formatNum(day_of_month," ")+
                "("+WEEK.charAt(day_of_week)+") "+
                formatNum(hour,  "0")+":"+
                formatNum(minute,"0")+":"+
                formatNum(second,"0"));

            //X[v
            try {
                Thread.sleep(1000);
            } catch (Exception e) {
            }
        }
    }

    //tH[}bg𐮂
    String formatNum(int num,String ume) {
        if (num<10) {
            return ume+num;
        } else {
            return ""+num;
        }
    }
}